<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.dk.mdm.mapper.mst.FollowPlanMapper">

    <!-- 通用设置 -->
    <!-- 通用查询列 -->
    <sql id="Base_Column_List">
        plan_id
        , cus_id, plan_type, follow_id, follow_user, next_follow_plan, next_follow_time,
        call_status, remarks, flg_valid, cp_id, op_create_time, op_create_user_id, op_update_time,
        op_update_user_id, op_app_code, op_timestamp, op_db_user,xxl_job_id
    </sql>

    <!-- 通用查询映射结果 -->
    <resultMap id="BaseResultMap" type="com.dk.mdm.model.pojo.mst.FollowPlan">
        <id column="plan_id" property="planId"/>
        <result column="cus_id" property="cusId" typeHandler="UuidTypeHandler"/>
        <result column="plan_type" property="planType"/>
        <result column="follow_id" property="followId" typeHandler="UuidTypeHandler"/>
        <result column="follow_user" property="followUser" typeHandler="UuidTypeHandler"/>
        <result column="next_follow_plan" property="nextFollowPlan"/>
        <result column="next_follow_time" property="nextFollowTime" typeHandler="TimestampTypeHandler"/>
        <result column="call_status" property="callStatus"/>
        <result column="remarks" property="remarks"/>
        <result column="flg_valid" property="flgValid"/>
        <result column="cp_id" property="cpId"/>
        <result column="op_create_time" property="opCreateTime" typeHandler="TimestampTypeHandler"/>
        <result column="op_create_user_id" property="opCreateUserId" typeHandler="UuidTypeHandler"/>
        <result column="op_update_time" property="opUpdateTime" typeHandler="TimestampTypeHandler"/>
        <result column="op_update_user_id" property="opUpdateUserId" typeHandler="UuidTypeHandler"/>
        <result column="op_app_code" property="opAppCode"/>
        <result column="op_timestamp" property="opTimestamp" typeHandler="TimestampTypeHandler"/>
        <result column="op_db_user" property="opDbUser"/>
        <result column="xxl_job_id" property="xxlJobId"/>
    </resultMap>

    <!-- 通用条件列 -->
    <sql id="Condition">
        <where>
            <if test="cusId != null and cusId != ''">
                AND cus_id = #{cusId}
            </if>
            <if test="planType != null">
                AND plan_type = #{planType}
            </if>
            <if test="followId != null and followId != ''">
                AND follow_id = #{followId}
            </if>
            <if test="followUser != null and followUser != ''">
                AND follow_user = #{followUser}
            </if>
            <if test="nextFollowPlan != null and nextFollowPlan != ''">
                AND next_follow_plan = #{nextFollowPlan}
            </if>
            <if test="nextFollowTime != null">
                AND next_follow_time = #{nextFollowTime}
            </if>
            <if test="callStatus != null and callStatus != ''">
                AND call_status = #{callStatus}
            </if>
            <if test="remarks != null and remarks != ''">
                AND remarks = #{remarks}
            </if>
            <if test="flgValid != null">
                AND flg_valid = #{flgValid}
            </if>
            <if test="cpId != null">
                AND cp_id = #{cpId}
            </if>
            <if test="opCreateTime != null">
                AND op_create_time = #{opCreateTime}
            </if>
            <if test="opCreateUserId != null and opCreateUserId != ''">
                AND op_create_user_id = #{opCreateUserId}
            </if>
            <if test="opUpdateTime != null">
                AND op_update_time = #{opUpdateTime}
            </if>
            <if test="opUpdateUserId != null and opUpdateUserId != ''">
                AND op_update_user_id = #{opUpdateUserId}
            </if>
            <if test="opAppCode != null and opAppCode != ''">
                AND op_app_code = #{opAppCode}
            </if>
            <if test="opTimestamp != null">
                AND op_timestamp = #{opTimestamp}
            </if>
            <if test="opDbUser != null and opDbUser != ''">
                AND op_db_user = #{opDbUser}
            </if>
        </where>
    </sql>

    <sql id="idsForeach">
        <!-- 根据主键planId批量操作 -->
        WHERE plan_id in
        <foreach collection="ids" index="index" item="item" separator="," open="(" close=")">
            #{item}
        </foreach>
    </sql>

    <!-- 查询表t_csm_follow_plan，（条件查询+分页）列表 -->
    <select id="selectByCond" resultMap="BaseResultMap">
        SELECT
        <include refid="Base_Column_List"/>
        FROM dkic_b.t_csm_follow_plan
        <include refid="Condition"/>
        <if test="pageSize != null and currentPage != null and pageSize != 0 and currentPage != 0">
            limit #{end} offset #{start}
        </if>
    </select>

    <!-- 查询表t_csm_follow_plan，（条件查询）个数 -->
    <select id="countByCond" resultType="Long">
        SELECT
        count(1)
        FROM dkic_b.t_csm_follow_plan
        <include refid="Condition"/>
    </select>

    <!-- 根据主键查询表t_csm_follow_plan的一行数据 -->
    <select id="selectById" resultMap="BaseResultMap">
        SELECT
        <include refid="Base_Column_List"/>
        FROM dkic_b.t_csm_follow_plan
        WHERE plan_id = #{planId}::uuid
    </select>

    <!-- 根据主键锁定表t_csm_follow_plan的一行数据 -->
    <select id="selectByIdForUpdate" resultMap="BaseResultMap">
        SELECT
        <include refid="Base_Column_List"/>
        FROM dkic_b.t_csm_follow_plan
        WHERE plan_id = #{planId}
        for update
    </select>

    <!-- 根据主键锁定表t_csm_follow_plan的多行数据 -->
    <select id="selectByIdsForUpdate" resultMap="BaseResultMap">
        SELECT
        <include refid="Base_Column_List"/>
        FROM dkic_b.t_csm_follow_plan
        <include refid="idsForeach"/>
        for update
    </select>

    <insert id="insertBatch">
        insert into dkic_b.t_csm_follow_plan
        (
        <trim suffixOverrides=",">
            cus_id,
            plan_type,
            follow_id,
            follow_user,
            next_follow_plan,
            next_follow_time,
            call_status,
            remarks,
            cp_id,
            op_app_code,
        </trim>
        )
        values
        <foreach collection="list" index="index" item="item" separator=",">
            (
            <trim suffixOverrides=",">
                #{item.cusId}::uuid,
                #{item.planType},
                #{item.followId}::uuid,
                #{item.followUser}::uuid,
                #{item.nextFollowPlan},
                #{item.nextFollowTime},
                #{item.callStatus},
                #{item.remarks},
                #{item.cpId},
                #{item.opAppCode},
            </trim>
            )
        </foreach>
    </insert>
</mapper>
